﻿Public Class App
    Shared _me As App = Nothing

    Public Shared ReadOnly Property Instance() As App
        Get
            If App._me Is Nothing Then
                App._me = New App
            End If
            Instance = App._me
        End Get
    End Property

    Private Sub New()
        ' UNDONE:
        'Tablet.Instance("tablet2").Commands("DrawFreehandLine").Add(New WindowsApplication1.Plugin.Commands.StandardBrushCommand)
        ' UNDONE:
        With Me
            Dim invokerName = "DrawFreehandLine"
            Dim tablet2 = Tablet.Instance("tablet2")
            Dim files = System.IO.Directory.GetFiles(System.IO.Path.Combine(System.Windows.Forms.Application.StartupPath, "Plugin"), "StandardBrush.dll", IO.SearchOption.AllDirectories).GetEnumerator()
            Do While files.MoveNext()
                Dim a = Reflection.Assembly.LoadFrom(DirectCast(files.Current, String))
                Dim types = a.GetTypes().GetEnumerator()
                Do While types.MoveNext()
                    Dim t = DirectCast(types.Current(), Type)
                    Debug.Print("Found:" & t.FullName)
                    If t.IsSubclassOf(Type.GetType("WindowsApplication1.Plugin.Command,WindowsApplication1.Plugin", True, True)) Then
                        tablet2.Commands(invokerName).Add(a.CreateInstance(t.FullName))
                    End If
                Loop
            Loop
        End With

        With Me
            Dim tablet1 = Tablet.Instance("tablet1")
            tablet1.Commands("DrawFreehandLine").Add(New WindowsApplication1.Plugin.Commands.NullBrushCommand)
        End With
    End Sub
End Class
