﻿Class Tablet
    Dim _strokeModifier As Api.StrokeModifier = New Plugin.Strokes.NullStroke
    Dim _commands As Dictionary(Of String, List(Of Api.Command)) = New Dictionary(Of String, List(Of Api.Command))

    ' FIXME:StringよりもInvokerに。
    Property StrokeModifier(ByVal invokerName As String) As Api.StrokeModifier
        Get
            StrokeModifier = Me._strokeModifier
        End Get
        Set(ByVal value As Api.StrokeModifier)
            Me._strokeModifier = value
        End Set
    End Property

    ' FIXME:StringよりもInvokerに。
    Property Commands(ByVal invokerName As String) As List(Of Api.Command)
        Get
            If Not Me._commands.ContainsKey(invokerName) Then
                Me._commands(invokerName) = New List(Of Api.Command)
            End If
            Commands = Me._commands(invokerName)
        End Get
        Set(ByVal value As List(Of Api.Command))
            Me._commands(invokerName) = value
        End Set
    End Property

    Public ReadOnly Property Id() As String
        Get
            Id = Me._id
        End Get
    End Property

    Shared _us = New Dictionary(Of String, Tablet)
    Dim _id As String
    Shared ReadOnly Property Instance(Optional ByVal id As String = Nothing) As Tablet
        Get
            If id Is Nothing OrElse Not Tablet._us.ContainsKey(id) Then
                Dim i = New Tablet(id)
                id = i._id
                Tablet._us(id) = i
            End If
            Instance = Tablet._us(id)
        End Get
    End Property

    Private Sub New(Optional ByVal id As String = Nothing)
        If id Is Nothing Then
            id = Me.GetHashCode()
        End If
        Me._id = id
    End Sub

End Class
